#!/bin/python3
import argparse
from simulation import simulation_wrapper2

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description='Simulation server cluster')
    parser.add_argument('--simulation_time', type=int, default=500, help='runtime of each individual simulation')
    parser.add_argument('--num_runs', type=int, default=10, help='number of simulations to run with a fixed set of parameters')
    parser.add_argument('--min_runs', type=int, default=5, help='minimum number of successful runs needed to calculate statistics')
    parser.add_argument('--confidence_level', type=float, default=0.95, help='confidence level')
    parser.add_argument('--best_c', action=argparse.BooleanOptionalAction, help='only run simulations for lambda=1 and determine the best C')

    args = parser.parse_args()

    if args.best_c:
        lambda_vals = [1,]
    else:
        lambda_vals = [l/100 for l in range(1, 301)]  # λ from 0.01 to 3.00


    simulation_wrapper2(args.simulation_time, args.num_runs, args.min_runs, args.confidence_level, lambda_vals)

